; -----------------------------------------------------------------------------
;	MSX ROM sample program
; =============================================================================
;	2019/07/14	t.hara
; -----------------------------------------------------------------------------

		include		"msx.asm"

		org			0x4000
		rom_header	entry_point

; -----------------------------------------------------------------------------
;	entry point
; -----------------------------------------------------------------------------
entry_point::
		ld			sp, [himem]
		call		initialize
		call		main
		jr			entry_point

; -----------------------------------------------------------------------------
;	paletteݒ}N
; -----------------------------------------------------------------------------
palette	macro		palette_no, red, green, blue
		ld			b, palette_no
		ld			de, ((green) << 8) | ((red) << 4) | (blue)
		call		set_palette
		endm

; -----------------------------------------------------------------------------
;	initialize
; -----------------------------------------------------------------------------
		scope		sc_initialize
initialize::
		;	COLOR 15, 0, 0
		ld			a, 15
		ld			[FORCLR], a
		xor			a, a
		ld			[BAKCLR], a
		ld			[BDRCLR], a

		;	SCREEN5
		ld			a, 5
		call		CHGMOD

		;	J[pbg
		di
		palette		 0, 0, 0, 0
		palette		 1, 1, 1, 1
		palette		 2, 2, 2, 2
		palette		 3, 3, 3, 3
		palette		 4, 4, 4, 4
		palette		 5, 5, 5, 5
		palette		 6, 6, 6, 6
		palette		 7, 7, 7, 7
		palette		 8, 0, 0, 0
		palette		 9, 1, 0, 0
		palette		10, 2, 0, 0
		palette		11, 3, 0, 0
		palette		12, 4, 0, 0
		palette		13, 5, 0, 0
		palette		14, 6, 0, 0
		palette		15, 7, 0, 0
		ei
		ret
		endscope

; -----------------------------------------------------------------------------
;	main
; -----------------------------------------------------------------------------
		scope		sc_main
main::
		call		draw_parts
		call		hmmm_1st_copy
		call		ymmm_2nd_copy
	end_loop:
		jp			end_loop
		endscope

; -----------------------------------------------------------------------------
;	HMMCR}hŃ̉摜VRAM֓]
; -----------------------------------------------------------------------------
		scope		sc_draw_parts
draw_parts::
		; ROMɂ鏉lDRAM֓]
		ld			hl, vdp_cmd_init
		ld			de, vdp_cmd_tbl
		ld			bc, 15
		ldir
		ld			hl, vdp_cmd_tbl
		di
		call		wait_vdp_command
		call		vdp_command

		ld			hl, pattern + 1
		ld			bc, ((0x80 | 15) << 8) | IO_VDP_PORT1
		ld			d, 0x80 | 44
		ld			a, 2
		;	R#15 = 2
		out			[c], a
		out			[c], b
	polling_loop:
		in			a, [c]
		bit			0, a
		jp			z, polling_exit		; CE bit  0 ɂȂĂAR}hIȂ̂Ŕ
		bit			7, a
		jp			z, polling_loop		; TR bit  0 ȂA܂ VDP  busy Ȃ̂Ŗ߂
		;	R#44 = [HL]
		ld			a, [hl]
		out			[c], a
		out			[c], d
		inc			hl
		jp			polling_loop
	polling_exit:
		;	R#15 = 0
		xor			a, a
		out			[c], a
		out			[c], b
		ei
		ret

	vdp_cmd_init:
		dw			0				; SX
		dw			0				; SY
		dw			0				; DX
		dw			0				; DY
		dw			16				; NX
		dw			16				; NY
		db			0x00			; CLR (pattern[0])
		db			0				; ARG
		db			VDPCMD_HMMC		; CMR

	pattern:
		db			0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 
		db			0x01, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x10
		db			0x01, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x10
		db			0x01, 0x23, 0x33, 0x33, 0x33, 0x33, 0x32, 0x10
		db			0x01, 0x23, 0x44, 0x44, 0x44, 0x44, 0x32, 0x10
		db			0x01, 0x23, 0x45, 0x55, 0x55, 0x54, 0x32, 0x10
		db			0x01, 0x23, 0x45, 0x66, 0x66, 0x54, 0x32, 0x10
		db			0x01, 0x23, 0x45, 0x67, 0x76, 0x54, 0x32, 0x10
		db			0x01, 0x23, 0x45, 0x67, 0x76, 0x54, 0x32, 0x10
		db			0x01, 0x23, 0x45, 0x66, 0x66, 0x54, 0x32, 0x10
		db			0x01, 0x23, 0x45, 0x55, 0x55, 0x54, 0x32, 0x10
		db			0x01, 0x23, 0x44, 0x44, 0x44, 0x44, 0x32, 0x10
		db			0x01, 0x23, 0x33, 0x33, 0x33, 0x33, 0x32, 0x10
		db			0x01, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x10
		db			0x01, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x10
		db			0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 
		endscope

; -----------------------------------------------------------------------------
;	HMMMR}hōɂP`Ă摜𕡐
; -----------------------------------------------------------------------------
		scope		sc_hmmm_1st_copy
hmmm_1st_copy::
		ld			hl, vdp_cmd
		di
		call		wait_vdp_command
		call		vdp_command
		ei
		ret

	vdp_cmd:
		dw			0				; SX
		dw			0				; SY
		dw			16				; DX
		dw			0				; DY
		dw			256-16			; NX
		dw			16				; NY
		db			0x00			; dummy
		db			0				; ARG
		db			VDPCMD_HMMM		; CMR
		endscope

; -----------------------------------------------------------------------------
;	YMMMR}hŏ񂠂摜ʈʂɉ摜𕡐
; -----------------------------------------------------------------------------
		scope		sc_ymmm_2nd_copy
ymmm_2nd_copy::
		ld			hl, vdp_cmd
		di
		call		wait_vdp_command
		call		vdp_command
		ei
		ret

	vdp_cmd:
		dw			0				; SX
		dw			0				; SY
		dw			0				; DX
		dw			16				; DY
		dw			256				; dummy
		dw			212-16			; NY
		db			0x00			; dummy
		db			0				; ARG
		db			VDPCMD_YMMM		; CMR
		endscope

; -----------------------------------------------------------------------------
;	SET_PALETTE
;	VDP ̃J[pbgɐFݒ肷
;	input)
;		B .... J[pbgԍ
;		DE ... 0b0000_0GGG_0RRR_0BBB
;	output)
;		Ȃ
;	break)
;		A, B, C
;	comment)
;		荞݋֎~ɌĂяo
; -----------------------------------------------------------------------------
		scope		sc_set_palette
set_palette::
		ld			a, 16
		call		vdp_write
		inc			c
		out			[c], e
		out			[c], d
		ret
		endscope

; -----------------------------------------------------------------------------
;	VDP_WRITE
;	VDP#Rn ɒl
;	input)
;		A .... ރWX^ԍn
;		B .... ޒl
;	output)
;		Ȃ
;	break)
;		C
;	comment)
;		荞݋֎~ɌĂяo
; -----------------------------------------------------------------------------
		scope		sc_vdp_write
vdp_write::
		or			a, 0x80
		ld			c, IO_VDP_PORT1
		out			[c], b
		out			[c], a
		ret
		endscope

; -----------------------------------------------------------------------------
;	SUBROUTINE
; -----------------------------------------------------------------------------
		USE_WAIT_VDP_COMMAND	0
		USE_VDP_COMMAND			0

; -----------------------------------------------------------------------------
;	PADDING
; -----------------------------------------------------------------------------
		rom_align

; -----------------------------------------------------------------------------
;	work area
; -----------------------------------------------------------------------------
vdp_cmd_tbl		:= 0xC000
vdp_cmd_sx		:= vdp_cmd_tbl
vdp_cmd_sy		:= vdp_cmd_sx + 2
vdp_cmd_dx		:= vdp_cmd_sy + 2
vdp_cmd_dy		:= vdp_cmd_dx + 2
vdp_cmd_nx		:= vdp_cmd_dy + 2
vdp_cmd_ny		:= vdp_cmd_nx + 2
vdp_cmd_clr		:= vdp_cmd_ny + 2
vdp_cmd_arg		:= vdp_cmd_clr + 1
vdp_cmd_cmr		:= vdp_cmd_arg + 1
